#
# Constraints for System controller support logic
#
set_property PACKAGE_PIN K16 [get_ports PL_pin_K16]
set_property PACKAGE_PIN K19 [get_ports PL_pin_K19]
set_property PACKAGE_PIN K20 [get_ports PL_pin_K20]
set_property PACKAGE_PIN L16 [get_ports PL_pin_L16]
set_property PACKAGE_PIN M15 [get_ports PL_pin_M15]
set_property PACKAGE_PIN N15 [get_ports PL_pin_N15]
set_property PACKAGE_PIN N22 [get_ports PL_pin_N22]
set_property PACKAGE_PIN P16 [get_ports PL_pin_P16]
set_property PACKAGE_PIN P22 [get_ports PL_pin_P22]

#
# On TE0706-02, select all 3 adjustable banks to 3.3V 
#

set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_P22]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_P16]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_N22]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_N15]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_M15]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_L16]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_K20]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_K19]
set_property IOSTANDARD LVCMOS33 [get_ports PL_pin_K16]

#
# Constraints for System controller support logic.
#

# PMOD 12 pin F2F cable can be used
# It also connects GND and 3.3V
# Connections of TEC0053 J17 with TE0706-02 J5     TEC0053 TE0706-02

set_property PACKAGE_PIN G20 [get_ports {SCLK}];  # J17:23 J5:48 
set_property PACKAGE_PIN E21 [get_ports {SDI1}];  # J17:19 J5:44
set_property PACKAGE_PIN B19 [get_ports {SDI2}];  # J17:17 J5:42
set_property PACKAGE_PIN D20 [get_ports {SDI3}];  # J17:15 J5:40
set_property PACKAGE_PIN G21 [get_ports {SDV}];   # J17:24 J5:47
set_property PACKAGE_PIN D21 [get_ports {ENC_A}]; # J17:20 J5:43 
set_property PACKAGE_PIN B20 [get_ports {ENC_B}]; # J17:18 J5:41 
set_property PACKAGE_PIN C20 [get_ports {ENC_I}]; # J17:16 J5:39 

set_property IOSTANDARD LVCMOS33 [get_ports SCLK]
set_property IOSTANDARD LVCMOS33 [get_ports SDI*]
set_property IOSTANDARD LVCMOS33 [get_ports SDV]
set_property IOSTANDARD LVCMOS33 [get_ports ENC_*]
set_property DRIVE 4 [get_ports SCLK]
set_property SLEW SLOW [get_ports SCLK]

# PMOD 12 pin F2F cable can be used
# It also connects GND and 3.3V
# Connections of TEC0053 J17 with TE0706-02 J5     TEC0053 TE0706-02

#set_property PACKAGE_PIN W16 [get_ports {gpio_0_tri_io[1]}]; # J17:3  J5:4
set_property PACKAGE_PIN W17 [get_ports {GH[2]}];  # J17:7   J5:8
set_property PACKAGE_PIN W20 [get_ports {GH[1]}];  # J17:9   J5:10
set_property PACKAGE_PIN AA16 [get_ports {GH[0]}]; # J17:11  J5:12
#set_property PACKAGE_PIN Y16 [get_ports {gpio_0_tri_io[0]}]; # J17:4  J5:3 
set_property PACKAGE_PIN W18 [get_ports {GL[2]}];  # J17:8   J5:7 
set_property PACKAGE_PIN W21 [get_ports {GL[1]}];  # J17:10  J5:9 
set_property PACKAGE_PIN AB16 [get_ports {GL[0]}]; # J17:12  J5:11

#set_property IOSTANDARD LVCMOS33 [get_ports gpio_0_tri_io*]
set_property IOSTANDARD LVCMOS33 [get_ports GH*]
set_property IOSTANDARD LVCMOS33 [get_ports GL*]
set_property DRIVE 4 [get_ports GL*]
set_property DRIVE 4 [get_ports GH*]
set_property SLEW SLOW [get_ports GL*]
set_property SLEW SLOW [get_ports GH*]

