set ::design_name zsys_sdsoc

# create hardware platform description
set pfm [sdsoc::create_pfm ${::design_name}.hpfm]
sdsoc::pfm_name $pfm "trenz.biz"  "xd" "${::design_name}" "1.0"
sdsoc::pfm_description $pfm "Trenz Basic SDSoC Platform"

sdsoc::pfm_clock       $pfm FCLK_CLK0 ps7 0 true proc_sys_reset_0
sdsoc::pfm_clock       $pfm FCLK_CLK1 ps7 1 false proc_sys_reset_1
sdsoc::pfm_clock       $pfm FCLK_CLK2 ps7 2 false proc_sys_reset_2
sdsoc::pfm_axi_port    $pfm M_AXI_GP0 ps7 M_AXI_GP
sdsoc::pfm_axi_port    $pfm M_AXI_GP1 ps7 M_AXI_GP
sdsoc::pfm_axi_port    $pfm S_AXI_ACP ps7 S_AXI_ACP
sdsoc::pfm_axi_port    $pfm S_AXI_HP0 ps7 S_AXI_HP
sdsoc::pfm_axi_port    $pfm S_AXI_HP1 ps7 S_AXI_HP
sdsoc::pfm_axi_port    $pfm S_AXI_HP2 ps7 S_AXI_HP
sdsoc::pfm_axi_port    $pfm S_AXI_HP3 ps7 S_AXI_HP

sdsoc::pfm_axis_port    $pfm S_AXIS tx_fifo S_AXIS
sdsoc::pfm_axis_port    $pfm S_AXIS dbg_fifo S_AXIS
sdsoc::pfm_axis_port    $pfm M_AXIS rx_fifo M_AXIS

for {set i 0} {$i < 16} {incr i} {
  sdsoc::pfm_irq       $pfm In$i irq_concat
}

# generate hardware platform
sdsoc::generate_hw_pfm $pfm

